Subject: Re: Q: bad routing table cache entries

From: Stas Sergeev <[email-masked]>
Date: Mon, 4 Jan 2016 04:32:49 +0300

04.01.2016 04:05, Sowmini Varadhan пишет:
> On (12/30/15 15:42), Stas Sergeev wrote:
>> 29.12.2015 18:22, Sowmini Varadhan пишет:
>>> Do you have admin control over the ubuntu router?
>>> If yes, you might want to check the shared_media [#] setting
>>> on that router for the interfaces with overlapping subnets.
>>> (it is on by default, I would try turning it off).
>> That didn't help, problem re-appears.
> the code that sets things up for redirect is this:
>
>    if (out_dev == in_dev && err && IN_DEV_TX_REDIRECTS(out_dev) &&
>              skb->protocol == htons(ETH_P_IP) &&
>              (IN_DEV_SHARED_MEDIA(out_dev) ||
>               inet_addr_onlink(out_dev, saddr, FIB_RES_GW(*res))))
>                  IPCB(skb)->flags |= IPSKB_DOREDIRECT;
>
> If you are still seeing the problematic redirect after disabling
> shared_media, then you would need to trace through inet_addr_onlink()
> to see why it was not returning false. As I said before, afaict from
> reading the code, inet_addr_onlink looks right. So there may be something
> unusual with your netmask config on in_dev/out_dev.
OK, thanks for the hint. Looks like a small function, I'll
trace it with systemtap a week later.
But I am more worrying about accepting such a redirects.
Almost certainly a bug.

> But even if the redirect is suppressed, sounds like the network/netmask
> config is sub-optimal, since each packet gets (needlessly?) sent
> up/down the router's in_dev/out_dev. That should be avoided, if possible.
Since I don't have a root access to the 192.168.0.1, I can't change
the masks. But curing the 192.168.8.1 router would give enough
of a relief too.